<?php

/*
 * Invision Power File Manager
 * Move To/Copy To Dialog
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 26th March 2003 
 *
 */

error_reporting(0);

if (!(include("./modules/header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// Get the variables
$original_file = param("f", "GET");
$original_dir  = param("d", "GET");
$act           = param("act", "GET");
$dir           = param("dir", "GET");

if ($act == 1 || $act == 2)
{
    $data["go"] = $move["move"];
}
else if ($act == 3 || $act == 4)
{
    $data["go"] = $move["copy"];
}
else
{
    $data["go"] = $move["copy"];
    $act = 1;
}

// Clean the paths
$dir            = cleanpath($dir);
$original_dir   = cleanpath($original_dir);
$original_file  = cleanpath($original_file);

if (eregi("win", PHP_OS) == TRUE)
{
    // Check for / in the URL even though the system is Windows (i.e. the user is using Opera)
    $dir = str_replace("/", "\\", $dir);
}

$path = $dir == "" ? $params["root"] : $params["root"] . $dir . $slash;

// Get the folders
$folders = traverse_dir($path);

// Parse some variables
$data["nav"] = $folders["nav"];

// Construct the array so that it parses as we want it to
$info["folders"] = "";
foreach ($folders["folders"] as $key => $var)
{
    $info["folders"][$key] = array("link" => "<a href=\"move.php?dir=" . str_replace("#", "%23", ereg_replace("^[/]", "", str_replace("\\", "/", $dir . $slash . $key))) . "&amp;act=" . $act . "&amp;f=" . str_replace("#", "%23", $original_file) . "&amp;d=" . str_replace("#", "%23", $original_dir) . "\">" . $key . "</a> (<a href=\"" . $params["root_url"] . "/" . ereg_replace("^[/]", "", str_replace("\\", "/", $dir . $slash . $key)) . "/\" target=\"_blank\">" . $main["view_dir"] . "</a>)", "name" => $key);
}
$info["up"] = $folders["up"];
$info["up"] = ereg_replace("\">", "&amp;act=" . $act . "&amp;f=" . $original_file . "&amp;d=" . $original_dir . "\">", $info["up"]);

// Get the dynamic data blocks from the template
$blocks = get_blocks(array("up", "folders"), $script_dir . "/settings/templates/move.tpl");

// Time to parse the blocks
$blocks["folders"]      = parse_block("folders");
$blocks["up"]           = parse_block("up");

// Finish up by outputting the completed pag
$parsed = dyn_template($blocks, $script_dir . "/settings/templates/move.tpl");

$data["javascript"]   = template($javascript, $script_dir . "/settings/templates/javascript/move.js");
$data["title"]        = $move["title"];
$data["charset"]      = $charset;
$data["gzip"]         = preg_replace("/%g/i", $gzip, $misc["gzip"]);
$data["copyright"]    = $copyright;
$data["act"]          = $act;
$data["dir"]          = js_safe(preg_replace("/\\\([0-9]+?)/i", "/$1", $dir));
$data["close"]        = $move["close"];
$data["o_dir"]        = js_safe($original_dir);
$data["o_file"]       = js_safe($original_file);
$data["main"]         = $scripts["main"];
$data["stats"]        = preg_replace("/%s/i", endtime($starttime), $misc["stats"]);

echo parse_dynamic($data, $parsed);
// We don't parse the global template for this window.

?>