<?php

/*
 * Invision Power File Manager
 * MySQL Manager Script
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 22nd February 2003 
 *
 */

error_reporting(0);

if (!(include("./modules/header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// The user doesn't have permission to access mysql
if ($params["mysql"] != 1)
{
    redirect($scripts["main"] . "?msg=no_per_sql");
}

$op         = param("op", "POST");
$databases  = explode(",", $params["dbname"]);

if($link_id = mysql_connect($params["dbhost"], $params["dbuser"], $params["dbpass"]) == FALSE)
{
    // There was an error connecting to MySQL
    $database["err_msg"] = mysql_error();
    $database["err_num"] = mysql_errno();
    $database["caption"] = $database["err_caption"];

    $data = template($database, $script_dir . "/settings/templates/mysql_err.tpl");
}
else
{
    if ($op == "query")
    {
        // The user is running a query
        $db = param("db", "POST");
        mysql_select_db($databases[$db]);

        // Assign some values
        list($version)          = mysql_fetch_row(mysql_query("SELECT VERSION() as version"));
        $database["version"]    = "MySQL " . $version;
        $database["database"]   = $databases[$db];
        $database["db"]         = $db;
        $database["sql"]        = htmlspecialchars(param("sql", "POST"));

        // Execute the query
        $result = mysql_query(param("sql", "POST"));

        if (empty($result))
        {
            // No result returned, there is was error in the SQL
            $database["err_msg"] = mysql_error();
            $database["err_num"] = mysql_errno();
            $database["caption"] = $database["err_caption"];

            $data = template($database, $script_dir . "/settings/templates/mysql_err.tpl");
        }
        else if (mysql_num_rows($result) == 0)
        {
            // Zero rows where returned, so it must have been a drop or create query
            $database["result"]     = $database["no_data"];
            $database["caption"]    = $database["res_caption"];
            $data = template($database, $script_dir . "/settings/templates/result.tpl");
        }
        else
        {
            // Rows where returned so produce a table of the output
            $header = "";
            for ($i=0; $i<mysql_num_fields($result); $i++)
            {
                // Produce a header field for each column name
                $headers .= "				<th class=\"mysql_header_cell\">" . mysql_field_name($result, $i) . "</th>\r\n";
            }

            $bodies = "";
            for ($i=0; $i<mysql_num_rows($result); $i++)
            {
                $bodies .= "			<tr class=\"mysql_data_row\">\r\n";
                $row_array = mysql_fetch_array($result);
    
                for ($j=0; $j<mysql_num_fields($result); $j++)
                {
                    // Make the output HTML safe
                    $data = htmlspecialchars($row_array[$j]);

                    if ($data == "")
                    {
                        // If the cell is empty pad it
                        $data = "&nbsp;";
                    }
                    else
                    {
                        // Convert line breaks
                        $data = preg_replace("/\r\n/i", "<br />", $data);
                        $data = preg_replace("/\r/i", "<br />", $data);
                        $data = preg_replace("/\n/i", "<br />", $data);
                        $data = preg_replace("/\t/i", "&nbsp;&nbsp;&nbsp;&nbsp;", $data);
                    }

                    $bodies .= "				<td class=\"mysql_data_cell\">" . $data . "</td>\r\n";
                }
                
                $bodies .= "			</tr>\r\n";
            }

            $database["result"] = "	<table class=\"mysql_results\"><thead><tr class=\"mysql_header_row\">$headers</tr></thead><tbody>$bodies</tbody></table>";

            $database["caption"] = $database["res_caption"];
            $data = template($database, $script_dir . "/settings/templates/result.tpl");
        }
    }
    else
    {
        // Get the ID of the database
        $db = param("db", "POST");
        $db = empty($db) == TRUE ? 0 : $db;

        list($version) = mysql_fetch_row(mysql_query("SELECT VERSION() as version"));
        $database["version"] = "MySQL " . $version;

        natcasesort($databases);

        $database["database"] = dropdown($databases, $db);

        // The user has yet to run a query so display the form
        $data = template($database, $script_dir . "/settings/templates/mysql.tpl");
    }

    mysql_close();
}

$page = array("javascript" => "", "content" => $data, "title" => $database["caption"], "this" => $PHP_SELF, "copyright" => $copyright, "areas" => area_buttons());
// Finish up by outputting the completed page
template($page, $script_dir . "/settings/templates/global.tpl");

?>