<?php

/*
 * Invision Power File Manager
 * Admin Header Library
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 2nd March 2003 
 *
 */

// A function to handle include errors
function include_error($msg)
{
    echo "<html>\r\n";
    echo "<head>\r\n";
    echo "<title>Error!</title>\r\n";
    echo "</head>\r\n";
    echo "<body bgcolor=\"#FFFFFF\">\r\n";
    echo "<center>\r\n";
    echo "<font face=\"verdana\" color=\"#000000\" size=\"1\"><b>" . $msg . "</b></font>\r\n";
    echo "</center>\r\n";
    echo "</body>\r\n";
    echo "</html>";
    exit();
}

set_magic_quotes_runtime(0);

if (!(include("../settings/settings.inc.php")))
{
    include_error("There was an error loading the  global settings file");
}

if (file_exists($script_dir) == FALSE)
{
    if (eregi("win", PHP_OS) == TRUE)
    {
        include_error("The script directory setting is invalid");
    }
    else
    {
        include_error("The script directory setting is invalid.<br />Remember that on Unix based platforms directory names are case sensitive");
    }
}

if (!(include($script_dir . "/modules/common.lib.php")))
{
    include_error("There was an error loading the common code module");
}
if (!(include($script_dir . "/modules/admin.lib.php")))
{
    include_error("There was an error loading the admin code module");
}
if (!(include($script_dir . "/settings/templates.inc.php")))
{
    include_error("There was an error loading the templates settings file");
}

if ($debug == TRUE)
{
    error_reporting(E_ALL);
}

$starttime  = starttime();
$PHP_SELF   = param("PHP_SELF", "SERVER");
$slash      = eregi("win", PHP_OS) ? "\\" : "/"; // Find out the correct trailing slash for the OS
$end        = $license == 1 ? "\r\n<br /><font face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" size=\"1\">{STATS}</font>" : "\r\n<br /><font face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" size=\"1\">{STATS}<br /><br />Powered by <a href=\"http://www.invisionfilemanager.com\" target=\"_blank\">Invision Power File Manager</a> v{VERSION} &copy 2003 <a href=\"http://www.invisionpower.com\" target=\"_blank\">Invision PS, Inc</a></font>";
$safe       = eregi("win", PHP_OS) == TRUE ? "\\" : "/";
$charset    = "iso-8859-1";
$fdata      = NULL;

// A list of system images NOT to allow to be shown or overwritten
$system = array("back.gif", "folder.gif", "openfolder.gif", "unknown.gif", "lockedfolder.gif", "lockedfile.gif");

// Build the JS list of valid images
$handle = opendir($script_dir . "/images/icons/");
$valid = "";
while($entry = readdir($handle))
{
    if (is_dir($entry) == FALSE && $entry != "." && $entry != ".." && in_array($entry, $system) == FALSE)
    {
        // Only display images
        if (preg_match('/\.gif$|\.jpg$|\.jpeg$|\.bmp$|\.png$/i', $entry) == TRUE)
        {
            $valid .= "'" . $entry . "', ";
        }
    }
}
closedir($handle);
$imgs = preg_replace("/'', $/", "", $valid); // Remove the trailing ,

// If the user is not on the login page, check for their cookie pass
if (basename($PHP_SELF) != "login.php")
{
    auth();
}

?>