<?php

/*
 * Invision Power File Manager
 * Control Panel Main Page
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 2nd March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

$p    = param("p", "GET");

$show = param("show", "GET");
if (empty($show) == TRUE)
{
    // If there is no "show" string, try loading the cookie
    $show = param("ipfm_show", "COOKIE");
}

if (empty($p) == TRUE)
{
    // No page has been called so we are using the frame page
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\r\n";
    echo "<html>\r\n";
    echo "<head>\r\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\"> \r\n";
    echo "<head>\r\n";
    echo "<title>Invision Power File Manager Control Panel</title>\r\n";
    echo "</head>\r\n";
    echo "<frameset cols=\"180,*\" frameborder=\"0\" border=\"0\" framespacing=\"0\">\r\n";
    echo "    <frame name=\"menu\" scrolling=\"auto\" noresize=\"noresize\" src=\"$PHP_SELF?p=menu\">\r\n";
    echo "    <frame name=\"main\" src=\"$PHP_SELF?p=main\">\r\n";
    echo "</frameset>\r\n";
    echo "<noframes>\r\n";
    echo "<body bgcolor=\"#FFFFFF\" text=\"#000000\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Sorry but you require a browser which supports frames</font></body>\r\n";
    echo "</noframes>\r\n";
    echo "</html>\r\n";
    exit();
}
else if ($p == "menu")
{
    // Call the menu page

    setcookie("ipfm_show", $show, time()+32400000); // Set the cookie for a year

    $pagetitle = "Control Panel Menu";
    $end = "";
    $show  = explode(";", $show);


    // IPS Services Menu
    $data = "<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"index.php?p=menu&show=1;2;3;4;5;6\" onmouseover=\"javascript:window.status='Expand All'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Expand All</a> | <a href=\"index.php?p=menu&show=none\" onmouseover=\"javascript:window.status='Collapse All'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Collapse All</a><br /><br />\r\n";
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "    <tr>\r\n";

    if (in_array(1, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(1) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- IPS Services</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"misc.php?op=news\" target=\"main\" onmouseover=\"javascript:window.status='IPS News'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">IPS News</a><br /><a href=\"misc.php?op=docs\" target=\"main\" onmouseover=\"javascript:window.status='Invision Power File Manager Documentation'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Documentation</a><br /><a href=\"http://www.ipshosting.com/\" target=\"_blank\" onmouseover=\"javascript:window.status='IPS Hosting'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">IPS Hosting</a><br /><a href=\"misc.php?op=update\" target=\"main\" onmouseover=\"javascript:window.status='Check for Updates'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Update Check</a><br /><a href=\"misc.php?op=support\" target=\"main\" onmouseover=\"javascript:window.status='Support &amp; Services'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Support &amp; Services</a></font></td>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(1) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ IPS Services</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">IPS News, Updates and Services</font></td>\r\n";
    }
    
    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<br />\r\n";
    
    // User Manager menu
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "    <tr>\r\n";

    if (in_array(2, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(2) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- Users</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"users.php?op=add\" target=\"main\" onmouseover=\"javascript:window.status='Add a New User'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Add User</a><br /><a href=\"users.php?op=edit\" target=\"main\" onmouseover=\"javascript:window.status='Edit an Existing User'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Edit User</a><br /><a href=\"users.php?op=del\" target=\"main\" onmouseover=\"javascript:window.status='Delete an Existing User'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Delete User</a></font></td>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(2) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ Users</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Add, edit or delete user accounts</font></td>\r\n";
    }
    
    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<br />\r\n";

    // File Templates Menu
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";

    if (in_array(3, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(3) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- File Templates</a></font></th>\r\n";
        $data .= "	  </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"templates.php?op=new\" target=\"main\" onmouseover=\"javascript:window.status='Create a new file template'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Create Template</a><br /><a href=\"templates.php?op=edit\" target=\"main\" onmouseover=\"javascript:window.status='Edit an existing file template'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Edit Template</a><br /><a href=\"templates.php?op=del\" target=\"main\" onmouseover=\"javascript:window.status='Delete an existing file template'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Delete Templates</a></font></td>\r\n";
        $data .= "	  </tr>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(3) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ File Templates</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Create, edit or delete file templates</font></td>\r\n";
    }

    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<br />\r\n";

    // Language Pack Menu
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";

    if (in_array(4, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(4) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- Languages</a></font></th>\r\n";
        $data .= "	  </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"languages.php?op=new\" target=\"main\" onmouseover=\"javascript:window.status='Create a New Language Pack'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Create New Pack</a><br /><a href=\"languages.php?op=edit\" target=\"main\" onmouseover=\"javascript:window.status='Edit an Existing Language Pack'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Edit an Existing Pack</a><br /><a href=\"languages.php?op=del\" target=\"main\" onmouseover=\"javascript:window.status='Delete a Language Pack'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Delete a Pack</a><br /><a href=\"languages.php?op=exp\" target=\"main\" onmouseover=\"javascript:window.status='Export a Language Pack'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Export a Pack</a><br /><a href=\"languages.php?op=imp\" target=\"main\" onmouseover=\"javascript:window.status='Import a Language Pack'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Import a Pack</a></font></td>\r\n";
        $data .= "	  </tr>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(4) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ Languages</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Manage language packs</font></td>\r\n";
    }

    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<br />\r\n";
    
    // Settings Menu
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";

    if (in_array(5, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(5) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- Settings</a></font></th>\r\n";
        $data .= "	  </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"script.php?op=settings\" target=\"main\" onmouseover=\"javascript:window.status='Script Settings'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Script Settings</a><br /><a href=\"script.php?op=ascii\" target=\"main\" onmouseover=\"javascript:window.status='ASCII File Types'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">ASCII File Types</a><br /><a href=\"script.php?op=types\" target=\"main\" onmouseover=\"javascript:window.status='File Type Association'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">File Association</a><br /><a href=\"script.php?op=vis\" target=\"main\" onmouseover=\"javascript:window.status='Visual Settings'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Visual Settings</a><br /><a href=\"script.php?op=names\" target=\"main\" onmouseover=\"javascript:window.status='File Names'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">File Names</a><br /><a href=\"system.php?op=list\" target=\"main\" onmouseover=\"javascript:window.status='System Templates'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">System Templates</a></font></td>\r\n";
        $data .= "	  </tr>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(5) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ Settings</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Configure many aspects of the system</font></td>\r\n";
    }

    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<br />\r\n";

    // Others Menu
    $data .= "<table border=\"0\" width=\"100%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";
    
    if (in_array(6, $show))
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(6) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Collapse Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">- Tools</a></font></th>\r\n";
        $data .= "	  </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"misc.php?op=info\" target=\"main\" onmouseover=\"javascript:window.status='Server Environment'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Server Environment</a><br /><a href=\"misc.php?op=icons\" target=\"main\" onmouseover=\"javascript:window.status='Upload File Icons'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Upload Icons</a><br /><a href=\"misc.php?op=lng\" target=\"main\" onmouseover=\"javascript:window.status='Upload Language Pack\\'s'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Upload Languages</a><br /><a href=\"misc.php?op=sec\" target=\"main\" onmouseover=\"javascript:window.status='Check System Security'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Security Check</a><br /><a href=\"misc.php?op=res\" target=\"main\" onmouseover=\"javascript:window.status='Script Resources'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Resources</a><br /><a href=\"misc.php?op=credits\" target=\"main\" onmouseover=\"javascript:window.status='Script Credits'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Credits</a></font></td>\r\n";
        $data .= "	  </tr>\r\n";
    }
    else
    {
        $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\"><a href=\"index.php?p=menu&show=" . menulink(6) . "\" style=\"color: #FFFFFF\" onmouseover=\"javascript:window.status='Expand Tab'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">+ Tools</a></font></th>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "	  <tr>\r\n";
        $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Tools for performing various tasks</font></td>\r\n";
     
    }

    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";
    $data .= "<p align=\"left\"><a href=\"login.php?op=out\" target=\"_top\" onmouseover=\"javascript:window.status='Log Out'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">Log Out</a><br /><br /><a href=\"../" . $scripts["login"] . "\" target=\"_top\" onmouseover=\"javascript:window.status='Return to File Manager'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">File Manager</a></p>\r\n";
}
else
{
    // Main page
    $pagetitle = "Control Panel Main Page";
    $data .= "</font></td>\r\n";
    $data .= "	  </tr>\r\n";
    $data .= "</table><br />\r\n";

    $data .= "<table border=\"0\" width=\"25%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";
    $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\">\r\n";
    $data .= "        <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">\r\n";
    $data .= "        <form action=\"http://www.hotscripts.com/cgi-bin/rate.cgi\" method=\"POST\" style=\"display:inline\" target=\"_blank\">\r\n";
    $data .= "        <input type=\"hidden\" name=\"ID\" value=\"11817\">\r\n";
    $data .= "        <table border=\"0\" cellspacing=\"0\" align=\"center\">\r\n";
    $data .= "            <tr>\r\n";
    $data .= "                <td>\r\n";
    $data .= "                <table border=\"0\" cellspacing=\"0\" width=\"100%\" bgcolor=\"#F5F5F5\" cellpadding=\"3\">\r\n";
    $data .= "                    <tr>\r\n";
    $data .= "                         <td align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Rate IPFM @ <a href=\"http://www.hotscripts.com\" target=\"_blank\">HotScripts.com</a></font></td>\r\n";
    $data .= "                    </tr>\r\n";
    $data .= "                    <tr>\r\n";
    $data .= "                         <td align=\"center\"><select name=\"ex_rate\" size=\"1\"><option value=\"5\">Excellent!</option><option value=\"4\">Very Good</option><option value=\"3\">Good</option><option value=\"2\">Fair</option><option value=\"1\">Poor</option></select></td>\r\n";
    $data .= "                    </tr>\r\n";
    $data .= "                    <tr>\r\n";
    $data .= "                        <td align=\"center\"><input type=\"submit\" value=\"Go!\"></td>\r\n";
    $data .= "                    </tr>\r\n";
    $data .= "                </table>\r\n";
    $data .= "                </td>\r\n";
    $data .= "             </tr>\r\n";
    $data .= "         </table>\r\n";
    $data .= "        </form>\r\n";

    $data = msg("Welcome to the File Manager Control Panel<br /><br />From here you can manage all aspects of your installation including User Management, Language Pack &amp; Template Management and System Settings<br /><br />You do not need to log out when you have finished using the Control Panel as your cookie will expire as soon as you shut your browser $data", "Welcome");
}

// Output the page
$endtime = endtime($starttime);
$page = array("END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>