<?php

/*
 * Invision Power File Manager
 * Misc Screens
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 2nd March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("language settings file");
}

// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

if ($op == "credits")
{
    // Display the credits page
    $pagetitle  = "Credits";

    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Authors</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Programmer:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"mailto:stephen@invisionfilemanager.com\">Stephen Ball</a> (<a href=\"http://www.invisionfilemanager.com\" target=\"_blank\">Web Site</a>)</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Graphics:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"mailto:ssf@ibskins.com\">SSF</a> (<a href=\"http://www.ibskins.com\" target=\"_blank\">Web Site</a>)</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Special Thanks to...</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The gang at <a href=\"http://forums.invisionboard.com/\" target=\"_blank\">Invision Power Board</a> who kept me motivated, including (in no particular order)<br /><br />Jason, Mark, PHPAlien, Lister, xqus, Aaron, Stewart, Rikki, Mezz, Monster, Sandro, SoftwareX, SSF, CitruS, Alex, Roadkill71, DavyBoy, Kirkland, skep, Zef, Wraith, jwinton, aent, Dymero, Joe, Charles &amp; of course Matt for getting me interesting in coding in the first place<br /><br />Thanks also to Robert Hammon &amp; anyone else off who I may have left out</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "icons")
{
    // Display the uploader form
    $pagetitle = "Icon Uploader";

    // If we are running on Windows, convert the "control character safe" path back to normal Windows paths
    if (eregi("win", PHP_OS))
    {
        $script_dir = str_replace("/r", "\\r", $script_dir);
        $script_dir = str_replace("/n", "\\n", $script_dir);
        $script_dir = str_replace("/t", "\\t", $script_dir);

        $script_dir = str_replace("/R", "\\R", $script_dir);
        $script_dir = str_replace("/N", "\\N", $script_dir);
        $script_dir = str_replace("/T", "\\T", $script_dir);
    }

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" enctype=\"multipart/form-data\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"upload_icon\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Select up to 10 icons to be uploaded</font></td>\r\n";
    $form .= "    </tr>\r\n";

    for ($i=1; $i<=10; $i++)
    {
        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"left\" width=\"1%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Icon " . $i . ":</b></font></td>\r\n";
        $form .= "        <td align=\"left\" width=\"99%\"><input type=\"file\" name=\"icons[$i]\" style=\"width: 90%\" /></td>\r\n";    
        $form .= "    </tr>\r\n";
    }

    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Upload Icons\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Image Path</b>: " . $script_dir . $slash . "images" . $slash . "icons" . $slash . "</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle);
}
else if ($op == "upload_icon")
{
    $files = param("icons", "FILES");

    $data .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";

    if ($files["name"][1] == "" && $files["name"][2] == "" && $files["name"][3] == "" && $files["name"][4] == "" && $files["name"][5] == "" && $files["name"][6] == "" && $files["name"][7] == "" && $files["name"][8] == "" && $files["name"][9] == "" && $files["name"][10] == "")
    {
        $pagetitle = "User Error";

        $data .= "    <tr>\r\n";
        $data .= "        <td colspan=\"2\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No files where selected</font></td>\r\n";
        $data .= "    </tr>\r\n";
    }
    else
    {
        $pagetitle = "Images Uploaded";

        $data .= "    <tr>\r\n";
        $data .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The results of your uploads are shown below</font></td>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "    <tr>\r\n";
        $data .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>File</i></font></td>\r\n";
        $data .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Result</i></font></td>\r\n";
        $data .= "    </tr>\r\n"; 

        for ($i=1; $i<=10; $i++)
        {
            $new = $script_dir . $slash . "images" . $slash . "icons" . $slash . $files["name"][$i];

            if ($files["name"][$i] != "")
            {
                if (in_array(basename($files["name"][$i]), $system) == TRUE)
                {
                    $msg = "File Ignored - You cannot overwrite system files";
                }
                else if (preg_match('/\.gif$|\.jpg$|\.jpeg$|\.bmp$|\.png$/i', $files["name"][$i]) == FALSE)
                {
                    $msg = "File Ignored - Not an image file";
                }
                else if (move_uploaded_file($files["tmp_name"][$i], $new) == FALSE)
                {
                    if ($files["error"][$i] == 1 || $files["error"][$i] == 2)
                    {
                        $msg = "Transfer Error - Too large";
                    }
                    else if ($files["error"][$i] == 3)
                    {
                        $msg = "Transfer Error - Partially uploaded";
                    }
                    else 
                    {
                        $msg = "Transfer Error - Unknown Error";
                    }
                }
                else
                {
                    $msg = "File Uploaded!";
                }

                $data .= "    <tr>\r\n";
                $data .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . basename($files["name"][$i]) . "</b></font></td>\r\n";
                $data .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $msg . "</font></td>\r\n";
                $data .= "    </tr>\r\n"; 
            }
        }
    }
    $data .= "</table>\r\n";

    $data = msg($data, $pagetitle);
}
else if ($op == "lng")
{
    // Display the uploader form
    $pagetitle = "Language Pack Uploader";

    // If we are running on Windows, convert the "control character safe" path back to normal Windows paths
    if (eregi("win", PHP_OS))
    {
        $script_dir = str_replace("/r", "\\r", $script_dir);
        $script_dir = str_replace("/n", "\\n", $script_dir);
        $script_dir = str_replace("/t", "\\t", $script_dir);

        $script_dir = str_replace("/R", "\\R", $script_dir);
        $script_dir = str_replace("/N", "\\N", $script_dir);
        $script_dir = str_replace("/T", "\\T", $script_dir);
    }

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" enctype=\"multipart/form-data\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"upload_lng\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Select up to 5 language packs to be uploaded</font></td>\r\n";
    $form .= "    </tr>\r\n";

    for ($i=1; $i<=5; $i++)
    {
        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"left\" width=\"1%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Language Pack " . $i . ":</b></font></td>\r\n";
        $form .= "        <td align=\"left\" width=\"99%\"><input type=\"file\" name=\"lng[$i]\" style=\"width: 90%\" /></td>\r\n";    
        $form .= "    </tr>\r\n";
    }

    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Upload Language Pack\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Language Pack Path</b>: " . $script_dir . $slash . "languages" . $slash . "</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle);
}
else if ($op == "upload_lng")
{
    $files = param("lng", "FILES");

    $data .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";

    if ($files["name"][1] == "" && $files["name"][2] == "" && $files["name"][3] == "" && $files["name"][4] == "" && $files["name"][5] == "")
    {
        $pagetitle = "User Error";

        $data .= "    <tr>\r\n";
        $data .= "        <td colspan=\"2\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No files where selected</font></td>\r\n";
        $data .= "    </tr>\r\n";
    }
    else
    {
        $pagetitle = "Language Packs Uploaded";

        $data .= "    <tr>\r\n";
        $data .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The results of your uploads are shown below<br />Now select the &quot;Import a pack&quot; option to install any uploaded language packs</font></td>\r\n";
        $data .= "    </tr>\r\n";
        $data .= "    <tr>\r\n";
        $data .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>File</i></font></td>\r\n";
        $data .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Result</i></font></td>\r\n";
        $data .= "    </tr>\r\n"; 

        for ($i=1; $i<=10; $i++)
        {
            $new = $script_dir . $slash . "languages" . $slash . $files["name"][$i];

            if ($files["name"][$i] != "")
            {
                if (file_exists($new) == TRUE)
                {
                    $msg = "File Ignored - You cannot overwrite existing files";
                }
                else if (preg_match('/\.lng.php$/i', $files["name"][$i]) == FALSE)
                {
                    $msg = "File Ignored - Not a language pack";
                }
                else if (move_uploaded_file($files["tmp_name"][$i], $new) == FALSE)
                {
                    if ($files["error"][$i] == 1 || $files["error"][$i] == 2)
                    {
                        $msg = "Transfer Error - Too large";
                    }
                    else if ($files["error"][$i] == 3)
                    {
                        $msg = "Transfer Error - Partially uploaded";
                    }
                    else 
                    {
                        $msg = "Transfer Error - Unknown Error";
                    }
                }
                else
                {
                    $msg = "File Uploaded!";
                }

                $data .= "    <tr>\r\n";
                $data .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . basename($files["name"][$i]) . "</b></font></td>\r\n";
                $data .= "        <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $msg . "</font></td>\r\n";
                $data .= "    </tr>\r\n"; 
            }
        }
    }
       
    $data .= "</table>\r\n";

    $data = msg($data, $pagetitle);
}
else if ($op == "sec")
{
    $server = param("SERVER_SOFTWARE", "SERVER");
   
    // Is the user running apache?
    if (preg_match("/apache/i", $server) == TRUE)
    {
        // Yes
        // Does the .htaccess file exist?
        if (file_exists($script_dir . "/settings/.htaccess") == TRUE)
        {   
            // Yes
            // Read the data
            $fp = fopen($script_dir . "/settings/.htaccess", "r");
            $fdata = fread($fp, filesize($script_dir . "/settings/.htaccess"));
            fclose($fp);

            // Is the data valid?
            if (preg_match("/<files " . $scripts["userlist"] . ">/i", $fdata) == TRUE && preg_match("/Deny from All/i", $fdata) == TRUE && preg_match("/<\/files>/i", $fdata) == TRUE)
            {
                // Yes
                $data = "You are running Apache, and the .htaccess file is in place, you are secure";
            }
            else
            {
                // No
                $data = "You are running Apache, but the .htaccess file is not valid. If you give users MySQL access others maybe able to view the database passwords by viewing the URL <a href=\"" . $script_url . "/settings/" . $scripts["userlist"] . "\" target=\"_blank\">" . $script_url . "/settings/" . $scripts["userlist"] . "</a><br /><br />You can test this out by visting the URL yourself, if you get an error page such as &quot;Internal Server Error 500&quot; or a blank screen, then you are safe<br /><br />If you can see the data you need to create a file called .htaccess and place the following data in it<br /><br />&nbsp;&nbsp;&lt;Files " . $scripts["userlist"] . "&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;Deny from All<br />&nbsp;&nbsp;&lt;/Files&gt;";
            }
        }
        else
        {
            // No
            // Is perl installed and configured to parse CGI?
            $data = "You are running Apache, but the .htaccess file is not in place. If you give users MySQL access others maybe able to view the database passwords by viewing the URL <a href=\"" . $script_url . "/settings/" . $scripts["userlist"] . "\" target=\"_blank\">" . $script_url . "/settings/" . $scripts["userlist"] . "</a><br /><br />You can test this out by visting the URL yourself, if you get an error page such as &quot;Internal Server Error 500&quot; or a blank screen, then you are safe<br /><br />If you can see the data you need to create a file called .htaccess and place the following data in it<br /><br />&nbsp;&nbsp;&lt;Files " . $scripts["userlist"] . "&gt;<br />&nbsp;&nbsp;&nbsp;&nbsp;Deny from All<br />&nbsp;&nbsp;&lt;Files&gt;";
        }
    }
    else
    {
        // No
        $data = "You are not running the Apache Server. If you give users MySQL access others maybe able to view the database passwords by viewing the URL <a href=\"" . $script_url . "/settings/" . $scripts["userlist"] . "\" target=\"_blank\">" . $script_url . "/settings/" . $scripts["userlist"] . "</a><br /><br />You can test this out by visting the URL yourself, if you get an error page such as &quot;Internal Server Error 500&quot; or a blank screen, then you are safe<br /><br />Otherwise you should contact your Server Admin and ask them to disallow access to the file " . $script_dir . $slash . "settings" . $slash . $scripts["userlist"] . " over the Internet";
    }

    $pagetitle = "Security Check";
    $data = msg($data, $pagetitle);
}
else if ($op == "info")
{
    // Get the PHP info
    ob_start();
    phpinfo(INFO_ALL);
    $data = ob_get_contents();
    ob_end_clean();

    // Clean the output to match the rest of the program

    // Hex Colours
    $data = str_replace("9999cc", "4682B4", $data);
    $data = str_replace("ccccff", "F5F5F5", $data);
    $data = str_replace("cccccc", "F5F5F5", $data);

    // HTML Cleanup
    $data = str_replace("width=\"600\"", "width=\"85%\"", $data); 
    $data = str_replace("<h1>Configuration</h1>", "<h2>Configuration</h1>", $data);
    $data = str_replace("PHPB8B5F2A0-3C92-11d3-A3A9-4C7B08C10000", "PHPB8B5F2A0-3C92-11d3-A3A9-4C7B08C10000\" target=\"_blank", $data);

    // CSS Cleanup
    $data = str_replace("h1 {", "h1 { color: #FFFFFF;", $data);
    $data = str_replace(".h {", ".h { color: #FFFFFF;", $data);
    $data = str_replace("a:link {", "a { color: #0000FF;", $data);
    $data = str_replace("a:hover {text-decoration: underline;}", "", $data);
    $data = str_replace("body, td { font-family: arial, helvetica, sans-serif; font-size: 10pt; }", "body, td { font-family: arial, helvetica, sans-serif; font-size: 12px; }", $data);
    $data = str_replace("th { font-family: arial, helvetica, sans-serif; font-size: 11pt; font-weight: bold; }", "th { color: #FFFFFF; font-family: arial, helvetica, sans-serif; font-size: 14px; font-weight: bold; }", $data);

    // Hide the PHP license so that people don't think it is the File Manager license
    $data = str_replace("<h2>PHP License</h2>", "<!-- <h2>PHP License</h2>", $data);
    $end  = str_replace("{STATS}", "This page took " . endtime($starttime) . " seconds to produce", $end);
    $end  = str_replace("{VERSION}", $version, $end);
    $data = str_replace("</body>", "--><p align=\"center\">$end</p></body>", $data);


    // Output the page without using the template
    echo $data;
    exit();
}
else if ($op == "news")
{
    // Redirect to IPS to show the IPS news
    header("Location: http://www.invisionfilemanager.com/news.php");
    exit();
}
else if ($op == "support")
{
    // Redirect to IPS to show the Support page
    header("Location: http://www.invisionfilemanager.com/support.php");
    exit();
}
else if ($op == "update")
{
    // Redirect to IPS to show the File Manager updates
    $v = rawurlencode($version);
    header("Location: http://www.invisionfilemanager.com/update.php?v=" . $v);
    exit();
}
else if ($op == "res")
{
    // Redirect to IPS to show the File Manager resources
    header("Location: http://www.invisionfilemanager.com/resources.php");
    exit();
}
else if ($op == "license")
{
    // Display the license key form
    $pagetitle = "Copyright Removal License";

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"update_license\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Enter the license key you were given when you purchased a copyright removal license</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"1%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>License Key:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"99%\"><input type=\"text\" name=\"key\" style=\"width: 90%\" /></td>\r\n";    
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Update License\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">You must <a href=\"http://customer.invisionpower.com/client.cgi?do=register&group=ipfm\" target=\"_blank\">purchase a copyright removal</a> before you attempt to remove the copyright</font></td>\r\n";
    $form .= "    </tr>\r\n";    
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle);
}
else if ($op == "update_license")
{
    $pagetitle = "Copyright Removal License";

    if (md5(param("key", "POST")) == "f94a77d45548d28733b3deb3962cec28")
    {
        if (update_config(NULL, 6) == FALSE)
        {
            // The license could not be updated
            $data = msg("Sorry but the license could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"" . param("PHP_SELF", "SERVER") . "?op=license\">Try again</a>", "Copyright Removal License");
        }
        else
        {
            // The settings have been updated
            $data = msg("The license has been updated", "Copyright Removal License");
        }
    }
    else
    {
        // A valid key was not entered
        $data = msg("Sorry you did not enter a valid license key. If you have not purchased a copyright removal you will need to do so before you try to remove the copyright notice<br /><br /><a href=\"http://customer.invisionpower.com/client.cgi?do=register&group=ipfm\" target=\"_blank\">Purchase copyright removal</a><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>", "Invalid Key");
    }
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>