<?php

/*
 * Invision Power File Manager
 * CHMOD Dialog
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 22nd February 2003 
 *
 */

error_reporting(0);

if (!(include("./modules/header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// Get the variables
$file = param("f", "GET");
$dir  = param("d", "GET");

// Clean the paths
$file  = cleanpath($file);
$dir   = cleanpath($dir);

if (eregi("win", PHP_OS) == TRUE)
{
    // Check for / in the URL even though the system is Windows (i.e. the user is using Opera)
    $dir = str_replace("/", "\\", $dir);
}

$path = $dir == "" ? $params["root"] . $file : $params["root"] . $dir . $slash . $file;

// Parse some variables
$data["file"]       = $dir == "" ? $slash . $file : $slash . $dir . $slash . $file;

if (is_dir($path) == TRUE)
{
    // The user is CHMODding a directory so add a slash
    $data["file"] = $data["file"] . $slash;
}

$data["file1"]      = $file;
$data["dir"]        = $dir;
$data["main"]       = $scripts["main"];
$data["invalid"]    = $javascript["octal_error"];
$data["close"]      = $chmod["close"];

$data["chmod"] = chmod_value($path);

// Get the CHMOD "parts"
$hund    = substr($data["chmod"], 0, 1) . "00";
$tens    = substr($data["chmod"], 1, 1) . "0";
$unit    = substr($data["chmod"], 2, 1);

$check_hund = array("700" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" checked=\"checked\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" checked=\"checked\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" checked=\"checked\" />"), "600" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" checked=\"checked\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" checked=\"checked\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" />"), "500" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" checked=\"checked\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" checked=\"checked\" />"), "400" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" checked=\"checked\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" />"), "300" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" checked=\"checked\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" checked=\"checked\" />"), "200" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" checked=\"checked\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" />"), "100" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" checked=\"checked\" />"), "000" => array("check1" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '400');\" />", "check2" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '200');\" />", "check3" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '100');\" />")); // Build an array of what to check for the possible hundred values
$check_tens = array("70" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" checked=\"checked\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" checked=\"checked\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" checked=\"checked\" />"), "60" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" checked=\"checked\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" checked=\"checked\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" />"), "50" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" checked=\"checked\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" checked=\"checked\" />"), "40" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" checked=\"checked\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" />"), "30" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" checked=\"checked\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" checked=\"checked\" />"), "20" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" checked=\"checked\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" />"), "10" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" checked=\"checked\" />"), "00" => array("check4" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '40');\" />", "check5" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '20');\" />", "check6" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '10');\" />")); // Build an array of what to check for the possible ten values
$check_unit = array("7" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" checked=\"checked\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" checked=\"checked\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" checked=\"checked\" />"), "6" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" checked=\"checked\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" checked=\"checked\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" />"), "5" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" checked=\"checked\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" checked=\"checked\" />"), "4" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" checked=\"checked\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" />"), "3" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" checked=\"checked\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" checked=\"checked\" />"), "2" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" checked=\"checked\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" />"), "1" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" checked=\"checked\" />"), "0" => array("check7" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '4');\" />", "check8" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '2');\" />", "check9" => "<input type=\"checkbox\" class=\"check\" onclick=\"javascript:update(this, '1');\" />")); // Build an array of what to check for the possible unit values

// Populate the "read" check boxes
foreach($check_hund as $key => $var)
{
    if ($key == $hund)
    {
        $data["check1"] = $var["check1"];
        $data["check2"] = $var["check2"];
        $data["check3"] = $var["check3"];
        break; // No need to check anymore
    }
}

// Populate the "write" check boxes
foreach($check_tens as $key => $var)
{
    if ($key == $tens)
    {
        $data["check4"] = $var["check4"];
        $data["check5"] = $var["check5"];
        $data["check6"] = $var["check6"];
        break; // No need to check anymore
    }
}

// Populate the "execute" check boxes
foreach($check_unit as $key => $var)
{
    if ($key == $unit)
    {
        $data["check7"] = $var["check7"];
        $data["check8"] = $var["check8"];
        $data["check9"] = $var["check9"];
        break; // No need to check anymore
    }
}

// Parse the language pack
foreach($chmod as $key => $var)
{
    $data[$key] = $var;
}

// Finish up by outputting the completed page
$javascript["main"]   = $scripts["main"];

$data["javascript"]   = template($javascript, $script_dir . "/settings/templates/javascript/chmod.js");
$data["charset"]      = $charset;
$data["gzip"]         = preg_replace("/%g/i", $gzip, $misc["gzip"]);
$data["copyright"]    = $copyright;
$data["stats"]        = preg_replace("/%s/i", endtime($starttime), $misc["stats"]);

echo template($data, $script_dir . "/settings/templates/chmod.tpl");

// We don't parse the global template for this window.

?>