<?php

$charset = "iso-8859-1"; // The character set to use

// Text used for template descriptions
$temp_description[0] = "Blank Text Document";
$temp_description[1] = "PHP Script";
$temp_description[2] = "Perl Script";
$temp_description[3] = "HTML Document";
$temp_description[4] = "Wireless Markup Document";

// Text used on the login page
$login["title"] = "Please Log in!";
$login["caption"] = "Login";
$login["instructions"] = "Please enter your details below to log in!";
$login["username"] = "Username:";
$login["password"] = "Password:";
$login["submit"] = "Log in!";
$login["error"] = "Invalid username or password, please try again.";
$login["language"] = "Language:";
$login["my_default"] = "My Default Language";
$login["default"] = "System Default";

// Misc text
// Note the %s for the parse time and the %g for the gzip status
$misc["stats"] = "This page took %s seconds to produce.";
$misc["gzip"] = "GZIP Compression was %g";
$misc["enabled"] = "enabled";
$misc["disabled"] = "disabled";

// Text used on the area buttons
$area["sql"] = "SQL Manager";
$area["out"] = "Log Out";
$area["home"] = "Jump to Home Directory";
$area["space"] = "Space Usage";
$area["pass"] = "Change Password";

// Text used on tool buttons
$tools["chmod"] = "CHMOD";
$tools["rename"] = "Rename";
$tools["unlink"] = "Delete";
$tools["edit"] = "Edit";
$tools["htpasswd"] = "Password Protect";
$tools["copy"] = "Copy";
$tools["move"] = "Move";

// Text used on the main page
$main["title"] = "File Manager";
$main["browse"] = "File Manager - Browsing directory %i";
$main["at"] = "at";
$main["up_alt"] = "Up one directory";
$main["total"] = "Total Space Used:";
$main["CHMOD"] = "CHMOD Value:";
$main["foldown"] = "Folder Owner:";
$main["foldgroup"] = "Folder Group:";
$main["fileown"] = "File Owner:";
$main["filegroup"] = "File Group:";
$main["modified"] = "Last Modified:";
$main["file_size"] = "File Size:";
$main["file_ops"] = "File Options";
$main["remote"] = "Filename";
$main["upload"] = "Upload Selected File";
$main["new_fold"] = "Create a new folder";
$main["new_file"] = "Create a new file";
$main["file_comp"] = "File Compression";
$main["zip"] = "Filename:";
$main["compress"] = "Compress Files";
$main["options"] = "Options:";
$main["store"] = "Store the compressed files on disk";
$main["send"] = "Download the compressed files";
$main["both"] = "Store on disk and then download";
$main["nodir"] = "The supplied directory doesn't exist! Using the user's root instead";
$main["local"] = "Local File:";
$main["upname"] = "Filename:";
$main["na"] = "N/A";
$main["gigabyte"] = "GB";
$main["megabyte"] = "MB";
$main["kilobyte"] = "KB";
$main["byte"] = "Bytes";
$main["checkfolder"] = "Check the box to compress the folder";
$main["checkfile"] = "Check the box to compress the file";
$main["dir_info"] = "Directory Information";
$main["cur_dir"] = "Current Directory:";
$main["is_root_lbl"] = "Is Root?";
$main["is_read_lbl"] = "Is Readable?";
$main["is_write_lbl"] = "Is Writable?";
$main["files_in_dir"] = "Files in this directory:";
$main["folders_in_dir"] = "Folders in this directory:";
$main["dir_notes"] = "Directory notes:";
$main["none"] = "None";
$main["yes"] = "Yes";
$main["no"] = "No";
$main["no_files"] = "There are no files in this directory";
$main["no_root"] = "<b>Fatal Error!</b><br /><br />The root directory does not exist, please contact the server admin";
$main["source"] = "View Source";
$main["view_dir"] = "Open Directory";
$main["files_lbl"] = "File/Folder";
$main["actions_lbl"] = "Tasks";
$main["zip_lbl"] = "Zip?";
$main["new_fold_name"] = "New Directory";
$main["multiple"] = "Upload Multiple Files";

// Text used for the legend
$legend["legend"] = "Icon legend";
$legend["folder_icon"] = "Folder";
$legend["sound_icon"] = "Sound file";
$legend["image_icon"] = "Image file";
$legend["movie_icon"] = "Movie file";
$legend["text_icon"] = "Text file";
$legend["pdf_icon"] = "Adobe Acrobat file";
$legend["script_icon"] = "Script";
$legend["sql_icon"] = "SQL or Database file";
$legend["zip_icon"] = "Compressed file";
$legend["html_icon"] = "HTML/CSS file";
$legend["exe_icon"] = "Executable file";
$legend["unknown_icon"] = "Unknown file type";
$legend["del_icon"] = "Delete";
$legend["rename_icon"] = "Rename";
$legend["chmod_icon"] = "CHMOD";
$legend["edit_icon"] = "Edit";
$legend["move_icon"] = "Move";
$legend["copy_icon"] = "Copy";
$legend["htpass_icon"] = "Password protect";
$legend["file_a_dir"] = "Files &amp; folders:";
$legend["file_only"] = "Files only:";
$legend["dir_only"] = "Folders only:";
$legend["lfold_icon"] = "Locked folder";
$legend["lfile_icon"] = "Locked file";

// Text used by JavaScript messages
// DO NOT change the +  name +  part of the code otherwise the JS won't work, also leave the \\r\\n with double slashes
$javascript["del_file"] = "Are you sure you want to delete the file named \\\"\" + name + \"\\\" ?";
$javascript["del_dir"] = "Are you sure you want to delete the folder named \\\"\" + name + \"\\\" ?";
$javascript["octal_error"] = "Please enter the permissions in octal and in only three digits. EG 755.";
$javascript["invalid"] = "The new name cannot contain any of the following characters:";
$javascript["rename"] = "Rename \\\"\" + name + \"\\\" to: ";
$javascript["no_name"] = "You must enter a file name";
$javascript["invalid_zip"] = "The filename cannot contain any of the following characters:";
$javascript["no_zip"] = "You must add at least 1 directory or file to the zip file";
$javascript["dir_no_name"] = "The new folder must have a name";
$javascript["no_upload"] = "Please select a file to upload";
$javascript["no_pass"] = "You must enter a password";
$javascript["not_match"] = "Your passwords do not match";
$javascript["short_pass"] = "Your new password must be at least 5 characters long";
$javascript["ie_only"] = "Sorry this feature requires Microsoft Internet Explorer";
$javascript["disable_wrap"] = "Disable Wrapping";
$javascript["enable_wrap"] = "Enable Wrapping";
$javascript["ht_pass"] = "Please enter a new password";
$javascript["ht_invalid"] = "Sorry but usernames and passwords may only contains letters, numbers and the underscore character";
$javascript["ht_short"] = "Sorry but usernames and passwords must be at least 5 characters long";
$javascript["pass_invalid"] = "Sorry but passwords may only contains letters, numbers and the underscore character";
$javascript["name_used"] = "Sorry but the username you supplied is already in use";

// Messages shown when the user performs an action
$operate["no_per_rename"] = "Sorry you do not have the required permissions to rename files and folders";
$operate["err_rename"] = "There was an error renaming the file";
$operate["renamed"] = "The file has been renamed";
$operate["not_exist"] = "The file does not exist";
$operate["no_per_delete"] = "Sorry you do not have the required permissions to delete files and folders";
$operate["err_delete"] = "There was an error deleting the file";
$operate["not_exist_dir"] = "The folder does not exist";
$operate["err_empty_dir"] = "There was an error emptying the folder";
$operate["err_delete_dir"] = "There was an error deleting the folder";
$operate["deleted"] = "The file has been deleted";
$operate["deleted_dir"] = "The folder has been deleted";
$operate["no_zlib"] = "Sorry your installation of PHP does not support file compression";
$operate["no_per_zip"] = "Sorry you do not have the required permissions to compress files";
$operate["err_zip"] = "Sorry there was an unknown error compressing the files";
$operate["zipped"] = "The files have been compressed";
$operate["no_per_over"] = "Sorry you do not have the required permissions to overwrite an existing file";
$operate["no_space"] = "Sorry you do not have enough free space to perform this task";
$operate["not_dir"] = "This feature can only be used on folders";
$operate["is_dir"] = "The name you supplied is a directory and so can't be deleted";
$operate["no_per_new_dir"] = "Sorry you do not have the required permissions to create a new folder";
$operate["no_per_new_file"] = "Sorry you do not have the required permissions to create a new file";
$operate["err_mkdir"] = "There was an error creating the new folder";
$operate["mkdir"] = "The new folder has been created";
$operate["dir_exists"] = "Sorry but it is impossible to overwrite an existing folder, please delete the existing one first";
$operate["no_per_upload"] = "Sorry you do not have the required permissions to upload a file";
$operate["err_upload"] = "There was an error uploading the file";
$operate["uploaded"] = "The file has been uploaded";
$operate["no_per_chmod"] = "Sorry you do not have the required permissions to CHMOD files or folders";
$operate["err_chmod"] = "There was an error CHMODing the file or folder";
$operate["chmoded"] = "The CHMOD command was successful";
$operate["no_per_pass"] = "Sorry you do not have the required permissions to change your password";
$operate["err_pass"] = "There was an error updating your password";
$operate["pass"] = "Your password has been updated";
$operate["no_per_sql"] = "Sorry you do not have the required permissions to use MySQL";
$operate["no_per_edit"] = "Sorry you do not have the required permissions to edit files";
$operate["no_file_edit"] = "You must select a file to edit";
$operate["open_err"] = "There was an unknown error reading the file";
$operate["save_err"] = "There was an unknown error saving the file";
$operate["saved"] = "The file has been updated";
$operate["save_new"] = "The new file has been created";
$operate["no_per_view"] = "Sorry but the Server Admin has disabled access to this directory, using the user's root instead";
$operate["no_per_htpass"] = "Sorry you do not have the required permissions to password protect a folder";
$operate["no_touch"] = "Sorry but to ensure system integrity is maintained the directory cannot be password protected";
$operate["ht_done"] = "The directory was successfully password protected";
$operate["ht_deleted"] = "The user was successfully deleted";
$operate["ht_edit"] = "The users password has been changed";
$operate["dot_hide"] = "Sorry but this file has been hidden";
$operate["no_per_copy"] = "Sorry you do not have the required permissions to copy files or folders";
$operate["no_per_move"] = "Sorry you do not have the required permissions to move files or folders";
$operate["no_such_source"] = "There was an error locating the source file or folder";
$operate["no_such_target"] = "The target directory does not exist";
$operate["err_copy"] = "There was an unknown error copying the file or folder";
$operate["err_move"] = "There was an unknown error moving the file or folder";
$operate["copied"] = "The file or folder was copied successfully";
$operate["moved"] = "The file or folder was moved successfully";
$operate["not_file"] = "This feature can only be used on files";
$operate["not_match"] = "Your passwords do not match";
$operate["short_pass"] = "Your new password must be at least 5 characters long";
$operate["pass_invalid"] = "Sorry but passwords may only contains letters, numbers and the underscore character";
$operate["locked"] = "Sorry but this file is currently being edited by another person";
$operate["no_edit"] = "Sorry but you are not allowed to edit this type of file";

// Text for the change password page
$changepass["title"] = "Change Password";
$changepass["newpass"] = "New Password:";
$changepass["newpass2"] = "Comfirm Password:";
$changepass["submit"] = "Change My Password";

// Text used on the server space page
$space["title"] = "Server Space";
$space["stats"] = "Figures";
$space["used_lbl"] = "Used Space:";
$space["free_lbl"] = "Free Space:";
$space["total_lbl"] = "Total Space:";
$space["no_gd"] = "No chart could be generated because GD was not found";
$space["alt_no_gd"] = "GD is not installed";
$space["alt_usage"] = "Space Usage";
$space["text_free"] = "Free Space";
$space["text_used"] = "Used Space";

// Text used on the SQL Manager page
$database["caption"] = "Database Manager";
$database["version_lbl"] = "Version:";
$database["database_lbl"] = "Database:";
$database["sql_lbl"] = "SQL:";
$database["submit"] = "Execute Query";
$database["err_msg_lbl"] = "Error Message:";
$database["err_num_lbl"] = "Error Number:";
$database["err_caption"] = "MySQL Error";
$database["res_caption"] = "Query Result";
$database["no_data"] = "Query executed successfully!";
$database["new"] = "New Query";
$database["result_lbl"] = "Result:";

// Text used on the Source highlighting page
$source["title"] = "View Source";
$source["no_file"] = "Please choose a file to view";
$source["err_caption"] = "Error";
$source["empty"] = "The file is empty";
$source["no_such_file"] = "The file does not exist";
$source["close"] = "Close";

// Text used on the file editor
$edit["edit"] = "Editing";
$edit["file_lbl"] = "Filename:";
$edit["submit"] = "Save changes";
$edit["new_file"] = "Untitled Document";
$edit["cancel"] = "Cancel";

// Text used on the archive log
// %name refers to the file name, %date is the date and %size is the file size
// %program is the program name and %version is the file version
$compress["create"] = "Creating archive \"%name\" on %date";
$compress["done"] = "Archive created successfully";
$compress["by"] = "Created by %program v%version";
$compress["file"] = "Adding file \"%name\" (%size) to archive";
$compress["folder"] = "Adding folder \"%name\" (%size) to archive";

// Messages used when there is an upload error
$upload["too_large"] = "The file is too large";
$upload["part_upload"] = "The file was only partially uploaded";

// Messages used on the CHMOD dialog
$chmod["owner"] = "Owner";
$chmod["group"] = "Group";
$chmod["public"] = "Public";
$chmod["title"] = "Run CHMOD";
$chmod["read"] = "Read:";
$chmod["write"] = "Write:";
$chmod["execute"] = "Execute:";
$chmod["octal"] = "Octal Value:";
$chmod["run"] = "CHMOD File";
$chmod["close"] = "Close";

// Messages used on the lock dialog
$move["title"] = "Select a Folder";
$move["move"] = "Move to Current Directory";
$move["copy"] = "Copy to Current Directory";
$move["close"] = "Close";

// Messages used on the upload page
// %i refers to the file number
$lock["user"] = "Username";
$lock["pass"] = "Password";
$lock["new"] = "New Users";
$lock["close"] = "Close";
$lock["create"] = "Create User";
$lock["title"] = "Protect Directory";
$lock["existing"] = "Existing Users";
$lock["edit"] = "Edit Password";
$lock["delete"] = "Delete User";

// Messages used on the move dialog
$uploads["results"] = "The status of your uploads are as follows:<br /><br />";
$uploads["submit"] = "Upload Selected Files";
$uploads["file"] = "Local File %i:";
$uploads["title"] = "Upload Multiple Files";
$uploads["exists"] = "File already exists";
$uploads["no_space"] = "Not enough free space";
$uploads["no_file"] = "You did not select any files to upload";

?>