<?php

/*
 * Invision Power File Manager
 * Server Space Script
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 22nd February 2003 
 *
 */

error_reporting(0);

if (!(include("./modules/header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// Get the usage statistics
$used      = dirsize($params["root"]);
$total     = $params["space"];
$free      = $total - $used;

// A small fix so that the chart is shown as full if the user has used more space than their limit
if ($free < 0)
{
    $free = 0;
}

// Convert to human readable format
$space["used"]      = size($used);
$space["total"]     = size($total);
$space["free"]      = size($free);

$used_rgb = $used_colour[0] . "," . $used_colour[1] . "," . $used_colour[2]; // Build the CSS RGB colours for "used" space
$free_rgb = $free_colour[0] . "," . $free_colour[1] . "," . $free_colour[2]; // Build the CSS RGB colours for "free" space

// Produce the image
if (gdinstalled() == TRUE)
{
    // GD is installed
    $graph = "<img src=\"images/chart.php?used=" . $used . "&free=" . $free . "\" width=\"180\" height=\"180\" alt=\"" . $space["alt_usage"] . "\" title=\"" . $space["alt_usage"] . "\"><br><input type=\"text\" size=\"5\" style=\"background-color:rgb($free_rgb)\" readonly=\"readonly\" class=\"space\" /> " . $space["text_free"] . "<br><br><input type=\"text\" size=\"5\" style=\"background-color:rgb($used_rgb)\" readonly=\"readonly\" class=\"space\" /> " . $space["text_used"];
}
else
{
    // GD is missing
    $graph = "<img src=\"images/nogd.gif\" width=\"180\" height=\"180\" alt=\"" . $space["alt_no_gd"] . "\" title=\"" . $space["alt_no_gd"] . "\"><br>" . $space["no_gd"];
}

// Display the graph
$data = template($space, $script_dir . "/settings/templates/space.tpl");
$page = array("javascript" => "", "content" => $data, "title" => $space["title"], "this" => $PHP_SELF, "copyright" => $copyright, "areas" => area_buttons(), "img" => $graph);

// Finish up by outputting the completed page
template($page, $script_dir . "/settings/templates/global.tpl");

?>